%Building the numerical FRF with extracted poles and zeros
clear all
close all hidden

dir_exe= 'C:\Users\Batuhan\SIMOMIMO\TEZ\'; % .m files
dir_resu='C:\Users\Batuhan\SIMOMIMO\TEZ\Resu\';% Folder containing results
dir_data='C:\Users\Batuhan\SIMOMIMO\TEZ\Data\';% Folder containing true data
dir_alpha='C:\Users\Batuhan\SIMOMIMO\TEZ\Alpha\';%Folder containing FRF_rec.m FRFs
fmin=2;   % Lower limit of the frequency band to analyse (7 dof case)
fmax=80.0;   % Upper limit of the frequency band to analyse (fmax<Fs/2) (7 dof case)
resol=8192;        %resolution of True FRF (DO NOT CHANGE)
SIMOinp = 3;            %Dof in which the force is applied
analyzeMO = 10; %Model order to be graphed and MAC
anmorange_from = 10; %model order to be analyzed from
anmorange_to = 30; %model order to analyze to


str=['cd ' dir_resu ';'];
eval(str);
load matmodi
load modi_modello
str=['cd ' dir_exe ';'];
eval(str);

n = size(matmodi, 2);       %model order
temp = size(matmodi ,1);
MAXFRF = (temp/n)-2;        %number of output channels
minvec = zeros(n,1);        %for error calculation later
clear temp

str=['cd ' dir_data ';'];
eval(str);
load check
str=['cd ' dir_exe ';'];
eval(str);

%diagonal elements a & b
a = (conj(teta))'*AA*teta;
a = diag(a);
b = (conj(teta))'*BB*teta;
b = diag(b);

%True numerical FRF
DofTrue = size(fr,1);
omegaTrue = 2*pi*fr;
ff=linspace(fmin,Fs/2,resol);
step=(fmax-Fs/2)/(resol-1);
FRF = zeros(DofTrue, DofTrue, length(ff));  
tic
for ii=1:DofTrue
    for j=1:DofTrue
        for fff=1:resol
            %FRF(ii,j,fff) = FRF_NUMinv(M, K, C0, fff, ii, j, ff);
            FRF(ii,j,fff) =FRF_NUM(teta, lam, fff, ii, j, ff, DofTrue, a, b);
        end
    end
end
toc

%set plotband
delta=abs(ff - fmin);
[xxx inmin] = min(delta);
fmin=ff(inmin);
delta=abs(ff - fmax);
[xxx inmax] = min(delta);
fmax=ff(inmax);
clear xxx
plotband = ff(inmin:inmax);

FRFNUMSUM=zeros(resol,1);
figure
for ii=1:DofTrue
    forplot=zeros(1,resol);
    forplot=squeeze(FRF(ii,SIMOinp,:));
    semilogy(plotband,abs(forplot(inmin:inmax)))
    xlabel('Frequency (Hz)')
    ylabel('ANALYTICAL FRF')
    grid on
    zoom on
    hold on
    FRFNUMSUM = FRFNUMSUM + abs(forplot);
end
figure
semilogy(plotband,abs(FRFNUMSUM(inmin:inmax)))
xlabel('Frequency (Hz)')
ylabel('SUM OF ANALYTICAL FRF')
grid on
zoom on
hold on

%ANALYTICAL VALUES

fana = abs(lam)/(2*pi);
zana = real(lam)./abs(lam);

%Obtaining the results of FRF_rec.m

str=['cd ' dir_alpha ';'];
eval(str);
for k=1:7
    str=['load FRF_' num2str(k) '.mat FRF_' num2str(k) ';'];
    eval(str);
end
load FRFSum.mat FRFSum
FRFSum = DofTrue * FRFSum;

%str=['Experimental FRF'];
%figure('Name', str)
%semilogy(plotband, abs(FRFSum(inmin:inmax))) %Because in FRF_rec.m FRFSum = TxySum/ndof;
%xlabel('Frequency (Hz)')
%ylabel('SUM OF EXPERIMENTAL FRF')
%grid on
%zoom on 
%hold on
 
str=['cd ' dir_resu ';'];
eval(str);
load matmodi
str=['cd ' dir_exe ';'];
eval(str);



for k=anmorange_from:anmorange_to  %k=5:n     %cycle on model order
   %initialisation
   resir = zeros(k, MAXFRF);     %residues
   freqr = zeros(k,1);           %frequency 
   omegr = zeros(k,1);           %frequency in rad/s
   zetar = zeros(k,1);           %damping ratio
   polir = zeros(k,1);           %poles
   for j=1:k                  %cycle to get values from matmodi
       freqr(j,1) = matmodi((k-1)*(2+MAXFRF)+1,j);
       zetar(j,1) = -matmodi((k-1)*(2+MAXFRF)+2,j);    %- because in matmodi zr values are negative
       for ii=1:MAXFRF
           resir(j,ii) = matmodi((k-1)*(2+MAXFRF)+(2+ii),j);
           resir(j,ii) = Fs .* resir(j,ii) ./ ((Fs/2)/(fmax-fmin)); %We multiply residues with sampling freq.
       end
   end
   omegr = 2*pi*freqr;
   for ii=1:k           %Cycle to build poles vector
       polir(ii,1) = (-zetar(ii,1)*omegr(ii,1) + i*omegr(ii,1)*sqrt(1-zetar(ii,1)^2));
   end
   FRFEXC = zeros(DofTrue, DofTrue, length(ff));    %initialise extracted FRF matrix
   for ii=1:DofTrue
       for fff=1:resol
           %fff is only the index, ff is the vector  from 0 to Fs/2
           FRFEXC(ii,SIMOinp,fff) = FRF_EXC(resir, polir, ii, fff, k, ff); %SIMOinp=3, we are only interested in that column
       end
   end
   str = ['Model Order' num2str(k)];
   FRFEXCSUM = zeros(resol,1);
   for ii=1:DofTrue %Cycle to compute som of all FRFs
       forplot=zeros(1,resol);
       forplot=squeeze(FRFEXC(ii,SIMOinp,:));
       FRFEXCSUM = FRFEXCSUM + abs(forplot);
   end
   if k == analyzeMO %manually set to avoid a lot of windows
    figure('Name', str)
    semilogy(plotband,abs(FRFEXCSUM(inmin:inmax))) %I can probably omit abs()
    xlabel('Frequency (Hz)')
    ylabel('SUM OF EXTRACTED FRF')
    grid on
    zoom on
    hold on
   end

%BEST MODEL ORDER IS SELECTED IN LEAST SQUARES SENSE
ERROR = zeros(resol,1);
ERROR = (FRFNUMSUM(inmin:inmax) - FRFEXCSUM(inmin:inmax)).^2;
SUMERROR = sum(ERROR);
str = ['Error of model order ' num2str(k) ' is ' num2str(SUMERROR)];
disp(str);
minvec(k,1) = SUMERROR;

    
end

minvec = minvec(anmorange_from:anmorange_to);
[minerr, index] = min(minvec);
BMO = index+anmorange_from-1; %Best Model Order
str = ['model of order ' num2str(BMO) ' has the minimum total error, which is ' num2str(minerr)];
disp(str);

%Comparison to Leonardo's work
FRFLEO = zeros(DofTrue, DofTrue, length(ff));    %initialise extracted FRF matrix
   for ii=1:DofTrue
       for fff=1:resol
           FRFLEO(ii,SIMOinp,fff) = FRF_LEO(modi_modello, ii, fff, ff ,Fs, fmin, fmax); %SIMOinp=3, we are only interested in that column
       end
   end
   FRFLEOSUM = zeros(resol,1);
   for ii=1:DofTrue %Cycle to compute som of all FRFs
       forplot=zeros(1,resol);
       forplot=squeeze(FRFLEO(ii,SIMOinp,:));
       FRFLEOSUM = FRFLEOSUM + abs(forplot);
   end
   str=['Algorithm of Leonardo'];
   figure('Name', str)
   semilogy(plotband,abs(FRFLEOSUM(inmin:inmax))) %I can probably omit abs()
   xlabel('Frequency (Hz)')
   ylabel('SUM OF EXTRACTED FRF')
   grid on
   zoom on
   hold on
   
BMO = analyzeMO;  %To manually set model order to examine
%MAC
resir = zeros(DofTrue);
for j=1:DofTrue                  %cycle to get values from matmodi
     for ii=1:MAXFRF
           resir(j,ii) = matmodi((BMO-1)*(2+MAXFRF)+(2+ii),j);
           resir(j,ii) = Fs .* resir(j,ii) ./ ((Fs/2)/(fmax-fmin)); %We multiply residues with sampling freq.
     end
end
   
MAC = zeros(DofTrue);
for i=1:DofTrue
    for j=1:DofTrue
        A1 = squeeze(resir(i,:));
        T1 = squeeze(modes(:,j));
        A2 = A1';
        T2 = T1';
        %dot product
        nom = 0;
        for k=1:DofTrue
            temp = A2(k)*T1(k);
            nom = nom+temp;
        end
        nom = abs(nom)^2;
        denom1 = 0;
        for k=1:DofTrue
            temp = A2(k)*A1(k);
            denom1 = denom1+temp;
        end
        denom2 = 0;
        for k=1:DofTrue
            temp = T2(k)*T1(k);
            denom2 = denom2+temp;
        end
        MAC(i,j) = nom / (denom1*denom2);
    end
end
xlswrite('MAC.xls',MAC);





